"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by vadimdez on 27/03/2017.
 */
var core_1 = require("@angular/core");
var g2_1 = require("g2");
var G2Component = (function () {
    function G2Component() {
        this.width = 600;
        this.height = 300;
        this.plotCfg = {};
        this.forceFit = false;
        this.configure = new core_1.EventEmitter();
        this.chart = null;
        this.chartId = "ngx-g2-" + (new Date()).getTime();
    }
    G2Component.prototype.ngAfterViewInit = function () {
        this.initChart();
    };
    /**
     * On updates
     * @param changes
     */
    G2Component.prototype.ngOnChanges = function (changes) {
        if (!this.chart) {
            return;
        }
        if ('forceFit' in changes) {
            if (this.forceFit) {
                this.chart.forceFit();
            }
            else {
                this.chart.changeSize(this.width, this.height);
            }
        }
        if ('width' in changes || 'height' in changes) {
            this.chart.changeSize(this.width, this.height);
        }
        if ('data' in changes) {
            this.chart.changeData(this.data);
        }
    };
    /**
     * Initialize chart with data
     */
    G2Component.prototype.initChart = function () {
        this.chart = new g2_1.default.Chart({
            id: this.chartId,
            width: this.width,
            height: this.height,
            plotCfg: this.plotCfg,
            forceFit: this.forceFit
        });
        this.chart.source(this.data, this.titles);
        this.configure.emit(this.chart);
        this.chart.render();
    };
    return G2Component;
}());
G2Component.decorators = [
    { type: core_1.Component, args: [{
                selector: 'g2',
                template: "<div [id]=\"chartId\"></div>"
            },] },
];
/** @nocollapse */
G2Component.ctorParameters = function () { return []; };
G2Component.propDecorators = {
    'data': [{ type: core_1.Input },],
    'titles': [{ type: core_1.Input },],
    'width': [{ type: core_1.Input },],
    'height': [{ type: core_1.Input },],
    'plotCfg': [{ type: core_1.Input },],
    'forceFit': [{ type: core_1.Input },],
    'configure': [{ type: core_1.Output },],
};
exports.G2Component = G2Component;
//# sourceMappingURL=g2.component.js.map